// package project;
/**
 * This will take the logical expression as a string and will generate the 
 * the truth table
 * @author Jobby Jacob
 * extensive modifications May 21, 2006
 * @ author Daniel D. Warner
 */

import mthsc865.datastructures.StackAL;
import java.io.*;
import java.util.*;
import java.math.*;

public class truthTable{
    protected int[][] table; // The truth table for the expression
    protected Node[] n;
    protected Node[] result; // An array of nodes to store the  post fix expression
    protected StackAL operator=new StackAL(); //Stack used to create post fix notation
    protected int[] charClass = new int[26];
    protected int count=0;  // Number of characters and operators excluding parenthisis
    protected int charCount=0; // Number of different characters to determine the number of rows in truth table
    private char c;

    
    // Checking the validity of expression
    public void validityCheck(String input)throws IOException{
        int length=input.length();
        int check=0;
        for(int i=0;i<length;i++){
            c=input.charAt(i);
            if(i==length-1){
                if(c=='*'||c=='+'||c=='~'){
                    throw new IOException("Invalid ending of expression");
                }
            }else if(c=='~'){
                if(input.charAt(i+1)=='*'||input.charAt(i+1)=='+'||input.charAt(i+1)==')'){
                    throw new IOException("Invalid expression");
                }
            }else if(c=='*'||c=='+'||c=='('){
                if(input.charAt(i+1)=='*'||input.charAt(i+1)=='+'||input.charAt(i+1)==')'){
                    throw new IOException("Invalid expression");
                }
            }else if(input.charAt(i+1)!='*'&&input.charAt(i+1)!='+'&&input.charAt(i+1)!=')'){
                throw new IOException("Invalid Expression");
            }
            if(input.charAt(i)<97||input.charAt(i)>122){
                if(c!='~'&&c!='*'&&c!='+'&&c!='('&&c!=')'){
                    throw new IOException("Invalid operator or character");
                } 
                else if(i==0&&(c=='+'||c=='*')){
                   throw new IOException("Expression began  with + or * operator");
                }else if(c=='('){
                    check++;
                }else if(c==')'){
                    check--;
                } 
            }
            
        }
        if(check!=0){
            throw new IOException("Right and left parenthesis didnot match");
        }
    }
    
    // The consructor for the truth table
    public truthTable(String input){
        int length=input.length();
        for (int j=0; j<26; j++) {
        charClass[j] = 0;
        }
        n=new Node[length];
        for(int i=0;i<length;i++){
            c=input.charAt(i);
            if(c=='*'||c=='~'||c=='+'){
                n[i]=new Node(c,count++); // Creating a Node object for the valid operator
            }else{
                if(c=='('||c==')'){
                 n[i]=new Node(c);      // Creating a Node object for the parenthisis               
                }else{
                    n[i]=new Node(c,count++);
                    if(c-97>=0){
                        if(charClass[c-97]==0){
                            charClass[c-97]=count; // Creating the Node object for the characters
                            charCount++;
                        }  
                    }
                    else{
                        break; 
                    }
                }
            }
        }
        
        result=new Node[count];
        table =new int[(int)Math.pow(2,charCount)][count];
    }
    
    // Filling the columns for the characters and building the post fix expression
    public void buildTable(String input){
        int length=input.length();
        int f=1;
        int tempCount=0;
        // Filling the columns for the characters
        for(int i=25;i>=0;i--){
            if(charClass[i]!=0){
                for(int j=0;j<(int)Math.pow(2, charCount);j=j+(int)Math.pow(2,f)){
                    int m=0;
                    while(m<((int)Math.pow(2, f))/2){
                        table[j+m][charClass[i]-1]=0;
                        m++;
                    }
                    while(m<(int)Math.pow(2, f)){
                        table[j+m][charClass[i]-1]=1;
                        m++;
                    }
                }
                f++;
            }
            
        }
        // Building the postfix expression
        int j=0;
        for(int i=0;i<length;i++){
            c=input.charAt(i);
            if(c=='*'){
                n[i].setPriority(2);
                if(!operator.isEmpty()){
                   Node h;
                   h=(Node)operator.peek();
                   while(h.getPriority()<=2){
                       h=(Node)operator.pop();
                       result[j++]=h;         //Putting the operation with higher priority to the post fix array
                       if(!operator.isEmpty()){
                        h=(Node)operator.peek();
                       }else{
                           break;
                       }
                   }
                }
                operator.push(n[i]); // Pushing the operator to the stack
                tempCount++;
            }else if(c=='+'){
                n[i].setPriority(3);
                if(!operator.isEmpty()){
                   Node h;
                   h=(Node)operator.peek();
                   while(h.getPriority()<=3){
                       h=(Node)operator.pop();
                       result[j++]=h;        //Putting the operation with higher priority to the post fix array
                       if(!operator.isEmpty()){
                        h=(Node)operator.peek();
                       }else{
                           break;
                       }
                   }
                }
                operator.push(n[i]); // Pushing the operator to the stack
                tempCount++;
            }else if(c=='~'){
                n[i].setPriority(1);
                operator.push(n[i]); // Pushing the operator to the stack
                tempCount++;
            }
            else if(c=='('){
                n[i].setPriority(4);
                operator.push(n[i]); // put the ( to the stack and look for next operator
            }else if(c==')'){
                Node h=(Node)operator.pop();
                while(h.character!='('){
                     result[j++]=h;  // Putting everything to the post fix array till ( is seen in the stack.
                     if(!operator.isEmpty())
                        h=(Node)operator.pop();
                     else{
                            break;
                     }
                }
            }else  if(charClass[c-97]==tempCount+1){
                result[j++]=n[i]; 
                tempCount++;
            }else{
                for(int k=0;k<(int)Math.pow(2, charCount);k++){
                    table[k][tempCount]=table[k][charClass[c-97]-1]; // Copying the column for the repeated characters
                }
                result[j++]=n[i];
                tempCount++;
            }
        }
        while(!operator.isEmpty()){
            Node h =(Node)operator.pop();
            result[j++]=h;    // putting all the remaining operators in the stack to the post fix array
        }
    }
    
    
    // Building the expression tree
    
    public void treeBuild(Node[] result,int count){
        for(int i=0;i<count;i++){
            
            Node h=result[i];
            if(h.character=='*'||h.character=='+'){
                Node temp=(Node)operator.pop(); // setting the prevoius two nodes in the  
                h.setRightchild(temp);          // post fix array as the left and right
                temp=(Node)operator.pop();      // children of the operator 
                h.setLeftChild(temp);
                operator.push(h);
            }
            else if(h.character=='~'){
                Node temp=(Node)operator.pop();  // setting the previous node as the left
                h.setLeftChild(temp);            // child of the operator ~
                operator.push(h);
            }else{
                operator.push(h);
            }
        }
    }
    
    
   // Evaluating the expression tree
    
   public void evalTree(Node root){
       if(root.leftChild!=null){          
           evalTree(root.leftChild);
           if(root.rightChild!=null){
            evalTree(root.rightChild);
           }
       }
       if(root.character=='~'){
           negate(root.leftChild.column, root.column);
       }else if(root.character=='*'){
           and(root.leftChild.column,  root.rightChild.column, root.column);
       }else if(root.character=='+'){
           or(root.leftChild.column,  root.rightChild.column, root.column);
       }
   }
   
   // The method for negate operation
    public void negate(int charColumn, int tableColumn){
        for(int i=0;i<(int)Math.pow(2, charCount);i++){
            if(table[i][charColumn]==0){
                table[i][tableColumn]=1;
            }else{
                table[i][tableColumn]=0;
            }
        }
    }
    
    // The method for the And operation
    
    public void and(int firstChar, int secondChar, int tableColumn){
        for(int i=0;i<(int)Math.pow(2, charCount);i++){
            table[i][tableColumn]=table[i][firstChar] * table[i][secondChar];
        }
    }
    
    // The method for the OR operation
    
    public void or(int firstChar, int secondChar, int tableColumn){
        for(int i=0;i<(int)Math.pow(2, charCount);i++){
            table[i][tableColumn]=table[i][firstChar] + table[i][secondChar];
            if(table[i][tableColumn]==2){
                table[i][tableColumn]=1;
            }
        }
    }
    
    public  static void main(String args[]){
        String input=args[0];
        System.out.println(input);
        for(int i=0;i<input.length();i++){
            if(input.charAt(i)=='('||input.charAt(i)==')'){
                //System.out.print(input.charAt(i));
            }else{
                System.out.print(input.charAt(i)+"  ");
            }
        }
        System.out.println();
        truthTable t=new truthTable(input);
        
        try{
        
           t.validityCheck(input);
        }catch(IOException e){
                System.out.println(e);
                System.exit(0);
        }
        finally{
            t.buildTable(input);
            t.treeBuild(t.result, t.count);
            t.evalTree(t.result[t.count-1]);
            for(int y=0;y<(int)Math.pow(2, t.charCount);y++){
            for(int m=0;m<t.count;m++){
                System.out.print(t.table[y][m]+"  ");
            }
            System.out.println();
        }
        }
    }
}
